
document.getElementsByName("bg_radio").forEach( e => e.addEventListener("change", readBG) );
eByID("volume_range").addEventListener("input", readAudio);
eByID("range_faces").addEventListener("input", initialize);
eByID("range_dice").addEventListener("input", initialize);
eByID("roll_button").addEventListener("click", startRoll);
eByID("faces_def_2").addEventListener("click", { n_faces: 2, handleEvent: setNFaces });
eByID("faces_def_4").addEventListener("click", { n_faces: 4, handleEvent: setNFaces });
eByID("faces_def_6").addEventListener("click", { n_faces: 6, handleEvent: setNFaces });
eByID("faces_def_8").addEventListener("click", { n_faces: 8, handleEvent: setNFaces });
eByID("faces_def_10").addEventListener("click", { n_faces: 10, handleEvent: setNFaces });
eByID("faces_def_12").addEventListener("click", { n_faces: 12, handleEvent: setNFaces });
eByID("faces_def_20").addEventListener("click", { n_faces: 20, handleEvent: setNFaces });
eByID("num_def_1").addEventListener("click", { n_dice: 1, handleEvent: setNDice });
eByID("num_def_2").addEventListener("click", { n_dice: 2, handleEvent: setNDice });
eByID("num_def_3").addEventListener("click", { n_dice: 3, handleEvent: setNDice });
eByID("num_def_6").addEventListener("click", { n_dice: 6, handleEvent: setNDice });
eByID("num_def_10").addEventListener("click", { n_dice: 10, handleEvent: setNDice });

var n_dice = 1;
var n_faces = 6;
var dice = [];
const url_dir = "";

var imgs = [];
for (var i = 1; i <= 6; i++) {
  img = newImage(url_dir + "images/" + i + ".png");
  imgs.push(img);
}
var img0 = newImage(url_dir + "images/0.png");

var se0 = new Audio(url_dir + "sounds/pi.mp3");
var ses = [ new Audio(url_dir + "sounds/pu.mp3"), 
            new Audio(url_dir + "sounds/pu.mp3"), 
            new Audio(url_dir + "sounds/pu.mp3"), 
          ];
var a_i = 0;
var volume = 0;


window.onload = () => {
  initialize();
};


function readNumOfDice() {
  var e = eByID("range_dice");
  n_dice = Math.min(100, e.value);
}
function readNumOfFaces() {
  var e = eByID("range_faces");
  n_faces = Math.min(100, e.value);
}
function readAudio() {
  var v = eByID("volume_range").value;
  se0.volume = v * 0.01;
  ses.forEach( se => se.volume = v * 0.01 );
}
function readBG() {
  var es_radio = document.getElementsByName("bg_radio");
  if (es_radio[0].checked) {
    eByID("bg").style.background = "#00ff00";
  } else if (es_radio[1].checked) {
    eByID("bg").style.background = "#ffffff";
  } else {
    eByID("bg").style.background = "#0000ff";
  }
}


function setNFaces() {
  if (this.n_faces < 2) return;
  if (this.n_faces > 100) return;
  eByID("range_faces").value = this.n_faces;
  initialize();
}

function setNDice() {
  if (this.n_dice < 1) return;
  if (this.n_dice > 100) return;
  eByID("range_dice").value = this.n_dice;
  initialize();
}

function initialize() {
  readNumOfFaces();
  readNumOfDice();
  readBG();
  readAudio();
  displayRadioSettings();

  hideSum();
  dice = [];
  for (var i = 0; i < n_dice; i++) {
    dice.push(0);
  }
  recreateCanvases();
}

function playSE(rolling) {
  if (rolling) {
    ses[a_i % 3].play();
    a_i++;
  } else {
    se0.play();
  }
}

function displaySum() {
  eByID("str_sum").textContent = "" + sumOfDice(dice);
}
function hideSum() {
  eByID("str_sum").textContent = "　";
}

function displayRadioSettings() {
  eByID("str_n_of_dice").innerText = eByID("range_dice").value;
  eByID("str_n_of_faces").innerText = eByID("range_faces").value;
}

function recreateCanvases() {
  // clear
  var e = eByID("dice_table");
  while (e.firstChild) {
    e.removeChild(e.firstChild);
  }

  // recreate
  for (var i = 0; i < n_dice; i++) {
    var id_str = "canvas_id_" + i;

    var e = document.createElement("canvas");
    e.setAttribute("id", id_str);
    e.setAttribute("width", "50");
    e.setAttribute("height", "50");
    e.setAttribute("class", "img_dice");

    eByID("dice_table").appendChild(e);
  }
  drawDice();
}

function filterDice(rolling) {
  var new_class = rolling ? "img_dice gray" : "img_dice";

  var es = Array.from( document.getElementsByClassName("img_dice") );
  es.forEach( e => e.setAttribute("class", new_class) );
}

function startRoll() {
  var t = 0;

  filterDice(true);

  function roll() {
    setElementsDisabled(true);

    if (t <= 59) {
      hideSum();

      if (t >= 22 && t % 4 != 0) { }
      else if (t >= 30 && t % 6 != 0) { } 
      else {
        var allow_same = (n_faces <= 3);
        oneRoll(allow_same);
        if (t % 2 == 0) playSE(true);
      }
    }
    else {
      oneRoll(true);
      playSE(false);
      displaySum();

      filterDice(false);
      setElementsDisabled(false);

      clearInterval(timer);
    }

    drawDice();
    t++;
  }

  var timer = setInterval(roll, 50);
}


function oneRoll(allowSameFace) {
  for (var i = 0; i < n_dice; i++) {
    if (allowSameFace) {
      dice[i] = randomInt(n_faces);
    }
    else {
      var k = randomInt(n_faces - 1);
      if (k >= dice[i]) { k++; }
      dice[i] = k;
    }
  }
}


function setElementsDisabled(b) {
  eByID("roll_button").disabled = b;
  eByID("range_faces").disabled = b;
  eByID("range_dice").disabled = b;
  var es = Array.from( document.getElementsByClassName("def_button") );
  es.forEach( e => e.disabled = b );
}


function drawDice() {
  for (var i = 0; i < n_dice; i++) {
    var canvas = document.querySelector("#canvas_id_" + i);
    var ctx = canvas.getContext("2d");

    if (n_faces <= 6) {
      drawImageToCanvas(canvas, imgs[dice[i]]);
    }
    else {
      drawImageToCanvas(canvas, img0);

      var d = dice[i] + 1;
      if (n_faces < 100) {
        var text = ("   " + d).slice(-2);
        ctx.font = "30px Meiryo";
        ctx.fillText(text, 6, 35);
      } else {
        var text = ("   " + d).slice(-3);
        ctx.font = "22px Meiryo";
        ctx.fillText(text, 6, 32);
      }
    }
  }
}

function drawImageToCanvas(canvas, img) {
  canvas.getContext("2d").clearRect(0, 0, canvas.width, canvas.height);
  canvas.getContext("2d").drawImage(img, 0, 0, canvas.width, canvas.height);
}

function newImage(s) {
  var i = new Image;
  i.src = s;
  return i;
}

function randomInt(max) {
  return Math.floor(Math.random() * max);
}

function sumOfDice(ns) {
  const reducer = (a, c) => a + (c + 1); // 0 <= c <= 5
  return ns.reduce(reducer, 0);
}

function eByID(str) {
  return document.getElementById(str);
}
